
/**************************************************************************
 *
 * Filename: list_files.c
 *
 * Purpose: Find files with a given extension.
 *
 * Creation date: 8 April, 2005
 *
 * Author: Steven Eschrich
 *
 * Update History
 * --------------
 * 4/8/05: Imported/repaired from old libaffy (AMH)
 *
 **************************************************************************/

#include <affy.h>
#include <utils.h>

char **affy_list_files(char *directory, char *extension)
{
  struct dirent *de;
  DIR *d;
  char **filelist = NULL;
  int max_chips = 0;

  filelist = NULL;
  max_chips = 0;
  d = opendir(directory);
  while ((de = readdir(d)) != NULL)
  {
    if (endsWith(de->d_name, extension))
    {
      if (max_chips % REALLOC_INCR == 0)
        filelist =
          REALLOC(filelist, (max_chips + REALLOC_INCR) * sizeof(char *));
      filelist[max_chips] =
        CALLOC(strlen(de->d_name) + strlen(directory) + 2, sizeof(char));
      sprintf(filelist[max_chips], "%s/%s", directory, de->d_name);
      max_chips++;
    }
  }
  closedir(d);

  /* Last spot in list is null */
  if (max_chips % REALLOC_INCR == 0)
    filelist = REALLOC(filelist, (max_chips + 1) * sizeof(char *));
  filelist[max_chips] = NULL;

  return filelist;
}
