
/**************************************************************************
 *
 * Filename: load_chip.c
 *
 * Purpose: Initialize an AFFY_CHIP structure from disk.
 *
 * Creation date: 
 *
 * Author: Steven Eschrich
 *
 *
 * Update History
 * --------------
 * 4/8/05: Imported/repaired from old libaffy (AMH)
 *
 **************************************************************************/

#include <affy.h>
#include <utils.h>

AFFY_CHIP *affy_load_chip(char *filename)
{
  AFFY_CELFILE *c;
  AFFY_CHIP *chip;

  /* First try and open the file, if not quit now */
  if ((c = affy_load_cel_file(filename)) == NULL)
    return NULL;

  /* OK, allocate storage */
  chip = CALLOC(1, sizeof(AFFY_CHIP));
  chip->cel = c;
  chip->filename = strdup(c->filename);

  return chip;
}
