
/*
   bits.c

   Handles all of the binary attribute issues. They include reading in a
   binary string (in hex form) and converting to the internal 
   representation, which is an array of unsigned char's. 
*/
#include <stdio.h>
#include <stdlib.h>
#include "utils.h"

/* Each bit position */
BYTE setbits[8] = { 128, 64, 32, 16, 8, 4, 2, 1 };

/* The functions are defined inline within utils.h. */

/********************************************************************
  Binary feature support
  This library support bit features (0/1) represented as an array
  of 8-bit bytes (unsigned chars). 
     
  There are several methods of working with them. Note that they
  are general not the best to use for large numbers of bits, since
  they are more inefficient than handling one byte at a time. But,
  they are simple to understand and use.
*********************************************************************/
