/**************************************************************************
 *
 * Filename: gcrma.c
 *
 * Purpose: implementation of GCRMA in C (Source: Bioconductor gcrma package)
 *
 * Creation date: 5/18/07
 *
 * Author: Debashis Sahoo
 *
 *
 * Update History
 * --------------
 * 5/18/07: Created
 *
 * $Id:$
 *
 **************************************************************************/

#include <affy_rma.h>

extern int rma_pb;

/*
 * Source : gcrma/src/computeAffinities.c
 */

int * gcrma_getSeq(char *pseq) {
    int *outMatrix;
    int i;
    
    outMatrix = CALLOC(4*strlen(pseq), sizeof(int));

    for (i = 0; i < strlen(pseq); i++) {
        if (pseq[i] == 'A')
            outMatrix[(i * 4)] = 1;
        else
            outMatrix[(i * 4)] = 0;

        if (pseq[i] == 'C')
            outMatrix[(i * 4)+1] = 1;
        else
            outMatrix[(i * 4)+1] = 0;

        if (pseq[i] == 'G')
            outMatrix[(i * 4)+2] = 1;
        else
            outMatrix[(i * 4)+2] = 0;

        if (pseq[i] == 'T')
            outMatrix[(i * 4)+3] = 1;
        else
            outMatrix[(i * 4)+3] = 0;
    }

    return(outMatrix);
}

double  **get_affinity_spline_coefs() {
  double ** res;
  int i;
  double coeff[15] = {
    -0.55004171, -0.58579091, -0.08870557, -0.47774242, 0.23205570,
    0.5800275, 0.6127442, 0.1029431, 0.5738881, -0.2833437,
    0.01350914, -0.02030805, -0.14747469, 0.05436463, -0.10124882
  };
  res = create_matrix(3, 5);
  for (i = 0; i < 3; i++) {
    memcpy(res[i], &coeff[i*5], 5 * sizeof(double));
  }
  return res;
}

