#include <wx/wx.h>
#include <wx/log.h>
#include <stdarg.h>
#include "util_log.h"

extern wxApp *wxapp;

#define BUFSIZE 1024
#define LOCUS   "%s:%d "
static void wx_debug_impl(char *msg,...);

/* This will involve C++ calls, but the function should not be mangled */
extern "C"
{
void debug_impl(int level, const char *msg, ...)
{
  char msgbuf[BUFSIZE];         /* Too risky to malloc in here. */
  va_list ap;

  if (debug_level >= level)
  {
    if ((strlen(LOCUS) + strlen(msg) + 1) > BUFSIZE)
    {
      wxLogDebug("Format string overflow within debug_impl()!");
      return;
    }
    else
    {
      strcpy(msgbuf, LOCUS);
      strncat(msgbuf, msg, BUFSIZE - strlen(LOCUS) - 1);
    }

    va_start(ap, msg);
		wx_debug_impl(msgbuf, _loc_file, _loc_line, ap);
    va_end(ap);

    wxapp->Yield();
  }
}
}
static void wx_debug_impl(char *msg,...)
{
	va_list ap;
	va_start(ap,msg);
	wxVLogDebug(msg, ap);
	va_end(ap);
}