#include <wx/wx.h>
#include <wx/log.h>
#include <stdarg.h>
#include <stdlib.h>
#include "util_log.h"

#define BUFSIZE 1024
#define LOCUS   "%s:%d "

/* The actual linkage to call wxWidgets */
static void wx_die_impl(char *msg, ...);

/* This will involve C++ calls, but the function should not be mangled */
extern "C"
{
void die_impl(const char *msg, ...)
{
  char msgbuf[BUFSIZE];         /* Too risky to malloc in here. */
  va_list ap;

  if ((strlen(LOCUS) + strlen(msg) + 1) > BUFSIZE)
  {
		wxLogFatalError("Format string overflow within die_impl()!");
    return;                     /* Silence compiler. */
  }
  else
  {
    strcpy(msgbuf, LOCUS);
    strncat(msgbuf, msg, BUFSIZE - strlen(LOCUS) - 1);
  }

  va_start(ap, msg);
	wx_die_impl(msgbuf,_loc_file,_loc_line,ap);
	va_end(ap);
  /* This code has no effect! */
  exit(1);
}
}

/*
 * This routine actually calls the wxWidget function, it needed
 * to be separate for the variable arguments.
 */
static void wx_die_impl(char *msg, ...)
{
	va_list ap;
	va_start(ap,msg);
	wxVLogFatalError(msg, ap);
	va_end(ap);
	
	return;
}
