#include <wx/wx.h>
#include <wx/log.h>
#include <stdarg.h>
#include "util_log.h"

extern wxApp *wxapp;

#define BUFSIZE 1024
#define LOCUS   "%s:%d "
static void wx_warn_impl(char *msg,...);

/* This will involve C++ calls, but the function should not be mangled */
extern "C"
{
void warn_impl(const char *msg, ...)
{
  char msgbuf[BUFSIZE];         /* Too risky to malloc in here. */
  va_list ap;

  if ((strlen(LOCUS) + strlen(msg) + 1) > BUFSIZE)
  {
    wxLogWarning("Format string overflow within warn_impl()!");
    return;
  }
  else
  {
    strcpy(msgbuf, LOCUS);
    strncat(msgbuf, msg, BUFSIZE - strlen(LOCUS) - 1);
  }

  va_start(ap, msg);
  wx_warn_impl(msgbuf, _loc_file, _loc_line, ap);
  va_end(ap);

  wxapp->Yield();
  return;
}
}

static void wx_warn_impl(char *msg, ...)
{
	va_list ap;
	
	va_start(ap,msg);
	wxVLogWarning(msg,ap);
	va_end(ap);
	return;
}