// -*- C++ -*- generated by wxGlade 0.3.5.1 on Wed Mar 16 12:14:01 2005

#include "gene.h"
#include "MASPanel.h"

/**
 * The MAS C interface must be defined here as C-code.
 * This section handles getter functions, the setters
 * are in the parent (MainFrame).
 */
extern "C" {
	void mi_init();
	int mi_getBackground();
	int mi_getMeanNormalization();
	int mi_getMeanNormalizationValue();
	int mi_getScaleProbesets();
	int mi_getScaleProbesetsValue();
		
	char *mi_getOutputFile();
	void mi_callRMA();
};


BEGIN_EVENT_TABLE(MASPanel, wxPanel)
EVT_CHECKBOX(ID_MASPanel_MeanNormalizationCheckBox, MASPanel::OnMeanNormalizationUpdate)
EVT_CHECKBOX(ID_MASPanel_ScaleProbesetValuesCheckBox, MASPanel::OnScaleProbesetsUpdate)
EVT_BUTTON(ID_ChooseMASOutputFile, MASPanel::ChooseOutputFile)
END_EVENT_TABLE()

MASPanel::MASPanel(wxWindow* parent, int id, const wxPoint& pos, const wxSize& size, long style):
    wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL)
{
    // begin wxGlade: MASPanel::MASPanel
    m_masOutputFileSizer_staticbox = new wxStaticBox(this, -1, wxT("Output File"));
    m_masOptionsSizer_staticbox = new wxStaticBox(this, -1, wxT("Options"));
    m_masBackgroundCheckBox = new wxCheckBox(this, -1, wxT("Use Background Correction"));
    m_useMeanNormalizationCheckBox = new wxCheckBox(this, ID_MASPanel_MeanNormalizationCheckBox, wxT("Use Mean Normalization"));
    m_useMeanNormalizationTextCtrl = new wxTextCtrl(this, -1, wxT(""));
    m_scaleProbesetsCheckBox = new wxCheckBox(this, ID_MASPanel_ScaleProbesetValuesCheckBox, wxT("Scale Probeset Values"));
    m_scaleProbesetsTextCtrl = new wxTextCtrl(this, -1, wxT("500"));
    m_masOutputFileTextCtrl = new wxTextCtrl(this, -1, wxT(""));
    m_selectMASOutputFileButton = new wxButton(this, ID_ChooseMASOutputFile, wxT("Select File..."));
    m_executeMASButton = new wxButton(this, ID_ExecuteMAS, wxT("Execute MAS"));

    set_properties();
    do_layout();
    // end wxGlade

    // Set all fields to the appropriate defaults
    mi_init();
    m_masBackgroundCheckBox->SetValue(mi_getBackground());
    m_useMeanNormalizationCheckBox->SetValue(mi_getMeanNormalization());
    wxString s;
    s.Printf("%d",mi_getMeanNormalizationValue());
    m_useMeanNormalizationTextCtrl->SetValue(s);
    m_useMeanNormalizationTextCtrl->Enable(mi_getMeanNormalization());
    m_scaleProbesetsCheckBox->SetValue(mi_getScaleProbesets());
    s.Printf("%d",mi_getScaleProbesetsValue());
    m_scaleProbesetsTextCtrl->SetValue(s);
    m_scaleProbesetsTextCtrl->Enable(mi_getScaleProbesets());      
    m_masOutputFileTextCtrl->SetValue(wxT(mi_getOutputFile()));
		
}


void MASPanel::set_properties()
{
    // begin wxGlade: MASPanel::set_properties
    m_masBackgroundCheckBox->SetToolTip(wxT("Background correct the data before processing."));
    m_masBackgroundCheckBox->SetValue(1);
    m_useMeanNormalizationCheckBox->SetToolTip(wxT("Normalize the data at the probe level before calculating signal."));
    m_useMeanNormalizationTextCtrl->SetToolTip(wxT("Enter the constant value to normalize raw probes to, prior to summarization."));
    m_scaleProbesetsCheckBox->SetToolTip(wxT("Scale probesets to a constant value so results are comparable across chips."));
    m_scaleProbesetsCheckBox->SetValue(1);
    m_scaleProbesetsTextCtrl->SetToolTip(wxT("Choose the target scaling value for each chip."));
    // end wxGlade
}


void MASPanel::do_layout()
{
    // begin wxGlade: MASPanel::do_layout
    wxBoxSizer* m_masPanelSizer = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* m_masInputSizer = new wxBoxSizer(wxVERTICAL);
    wxStaticBoxSizer* m_masOutputFileSizer = new wxStaticBoxSizer(m_masOutputFileSizer_staticbox, wxHORIZONTAL);
    wxStaticBoxSizer* m_masOptionsSizer = new wxStaticBoxSizer(m_masOptionsSizer_staticbox, wxVERTICAL);
    wxBoxSizer* m_scaleProbesetsSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* m_meanNormalizationSizer = new wxBoxSizer(wxHORIZONTAL);
    m_masOptionsSizer->Add(m_masBackgroundCheckBox, 0, wxALL|wxALIGN_CENTER_HORIZONTAL, 15);
    m_meanNormalizationSizer->Add(m_useMeanNormalizationCheckBox, 0, wxRIGHT, 10);
    m_meanNormalizationSizer->Add(m_useMeanNormalizationTextCtrl, 0, 0, 0);
    m_masOptionsSizer->Add(m_meanNormalizationSizer, 0, wxALL|wxALIGN_CENTER_HORIZONTAL, 15);
    m_scaleProbesetsSizer->Add(m_scaleProbesetsCheckBox, 0, wxRIGHT|wxEXPAND, 15);
    m_scaleProbesetsSizer->Add(m_scaleProbesetsTextCtrl, 0, 0, 0);
    m_masOptionsSizer->Add(m_scaleProbesetsSizer, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 15);
    m_masInputSizer->Add(m_masOptionsSizer, 1, wxEXPAND, 0);
    m_masOutputFileSizer->Add(m_masOutputFileTextCtrl, 1, 0, 0);
    m_masOutputFileSizer->Add(m_selectMASOutputFileButton, 0, 0, 0);
    m_masInputSizer->Add(m_masOutputFileSizer, 0, wxEXPAND, 0);
    m_masPanelSizer->Add(m_masInputSizer, 1, wxEXPAND, 0);
    m_masPanelSizer->Add(m_executeMASButton, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SetAutoLayout(true);
    SetSizer(m_masPanelSizer);
    m_masPanelSizer->Fit(this);
    m_masPanelSizer->SetSizeHints(this);
    // end wxGlade
}

void MASPanel::OnMeanNormalizationUpdate(wxCommandEvent& WXUNUSED(event))
{
  bool editable=m_useMeanNormalizationCheckBox->IsChecked();
  m_useMeanNormalizationTextCtrl->Enable(editable);
}

void MASPanel::OnScaleProbesetsUpdate(wxCommandEvent& WXUNUSED(event))
{
  bool editable=m_scaleProbesetsCheckBox->IsChecked();
  m_scaleProbesetsTextCtrl->Enable(editable);
}

void MASPanel::ChooseOutputFile(wxCommandEvent& WXUNUSED(event))
{
	// Ask for file
	  wxFileDialog dialog
                 (
                    this,
                    _T("Save Expressions..."),
                    _T(""),
                    _T("mas-exprs.txt"),
                    _T(""),
                    wxSAVE
                 );
		if (dialog.ShowModal() == wxID_OK)
			m_masOutputFileTextCtrl->SetValue(dialog.GetPath());
}

wxString MASPanel::GetOutputFile()
{
	return m_masOutputFileTextCtrl->GetValue();	
}

int MASPanel::GetBackground()
{
	return m_masBackgroundCheckBox->IsChecked();
}

int MASPanel::GetMeanNormalization()
{
	return m_useMeanNormalizationCheckBox->IsChecked();
}
int MASPanel::GetMeanNormalizationValue()
{
	long val;
	m_useMeanNormalizationTextCtrl->GetValue().ToLong(&val);
	return (int)val;
}
int MASPanel::GetScaleProbesets()
{
	return m_scaleProbesetsCheckBox->IsChecked();
}

int MASPanel::GetScaleProbesetsValue()
{
	long val;
	m_scaleProbesetsTextCtrl->GetValue().ToLong(&val);
	return (int)val;
}
