// -*- C++ -*- generated by wxGlade 0.3.5.1 on Thu Mar 10 10:23:00 2005

#include <wx/config.h>
#include <wx/fs_zip.h>
#include "LogTextCtrl.h"
#include "MainFrame.h"
#include "gene.h"

extern wxApp * wxapp;
/**
 * The C interface (RMA/MAS) must be defined here as 
 * C-code.
 * This section handles setter functions to handle
 * the state of static variables to pass to RMA.
 */
extern "C" {
  void mi_setBackground(int);
  void mi_setMeanNormalization(int);
  void mi_setMeanNormalizationValue(int);
  void mi_setScaleProbesets(int);
  void mi_setScaleProbesetsValue(int);
  
  void ri_setBackground(int);
  void ri_setNormalization(const char *);
  
  void mi_setOutputFile(const char *);
  void ri_setOutputFile(const char *);
  void mi_setCDFDirectory(const char *);
  void ri_setCDFDirectory(const char *);
  void mi_callMAS(char **files);
  void ri_callRMA(char **files);
};


BEGIN_EVENT_TABLE(MainFrame, wxFrame)
EVT_MENU(ID_FileAddCELFilesMenu, MainFrame::OnFileAddCELFiles)
EVT_MENU(ID_FileExitMenu, MainFrame::OnExit)
EVT_MENU(ID_EditPreferencesMenu, MainFrame::OnEditPreferences)
EVT_MENU(ID_HelpAboutMenu, MainFrame::OnAbout)
EVT_MENU(ID_HelpHelpMenu, MainFrame::OnHelp)
EVT_BUTTON(ID_ExecuteRMA, MainFrame::ExecuteRMA)
EVT_BUTTON(ID_ExecuteMAS, MainFrame::ExecuteMAS)
END_EVENT_TABLE()

MainFrame::MainFrame(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE)
{
    // begin wxGlade: MainFrame::MainFrame
    panel_1 = new wxPanel(this, -1);
    sizer_3_staticbox = new wxStaticBox(panel_1, -1, wxT("Log Window"));
    m_notebook = new wxNotebook(this, -1, wxDefaultPosition, wxDefaultSize, 0);
    m_menuBar = new wxMenuBar();
    SetMenuBar(m_menuBar);
    wxMenu* fileMenu = new wxMenu();
    fileMenu->Append(ID_FileAddCELFilesMenu, wxT("Add CEL Files"), wxT("Add CEL files to list"), wxITEM_NORMAL);
    fileMenu->Append(ID_FileExitMenu, wxT("Exit"), wxT("Exit Program"), wxITEM_NORMAL);
    m_menuBar->Append(fileMenu, wxT("File"));
    wxMenu* editMenu = new wxMenu();
    editMenu->Append(ID_EditPreferencesMenu, wxT("Preferences"), wxT(""), wxITEM_NORMAL);
    m_menuBar->Append(editMenu, wxT("Edit"));
    wxMenu* wxglade_tmp_menu_1 = new wxMenu();
    wxglade_tmp_menu_1->Append(ID_HelpAboutMenu, wxT("About"), wxT(""), wxITEM_NORMAL);
    wxglade_tmp_menu_1->Append(ID_HelpHelpMenu, wxT("Help"), wxT(""), wxITEM_NORMAL);
    m_menuBar->Append(wxglade_tmp_menu_1, wxT("Help"));
    m_statusBar = CreateStatusBar(1, 0);
    m_celFileSelectionPanel = new CELFileSelectionPanel(m_notebook, -1, wxDefaultPosition, wxDefaultSize, 0);
    m_rmaPanel = new RMAPanel(m_notebook, -1, wxDefaultPosition, wxDefaultSize, 0);
    m_masPanel = new MASPanel(m_notebook, -1, wxDefaultPosition);
    m_logWindow = new wxTextCtrl(panel_1, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY);

    set_properties();
    do_layout();
    // end wxGlade
    
  m_logger=new LogTextCtrl(m_logWindow);
  
  m_logOld = wxLog::SetActiveTarget(m_logger);
  wxLogMessage(_T("GENE initialized.\n"));
}

MainFrame::MainFrame(wxWindow* parent, int id, const char* title_a, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, wxString(title_a, wxConvUTF8), pos, size, wxDEFAULT_FRAME_STYLE)
{
    // begin wxGlade: MainFrame::MainFrame
    panel_1 = new wxPanel(this, -1);
    sizer_3_staticbox = new wxStaticBox(panel_1, -1, wxT("Log Window"));
    m_notebook = new wxNotebook(this, -1, wxDefaultPosition, wxDefaultSize, 0);
    m_menuBar = new wxMenuBar();
    SetMenuBar(m_menuBar);
    wxMenu* fileMenu = new wxMenu();
    fileMenu->Append(ID_FileAddCELFilesMenu, wxT("Add CEL Files"), wxT("Add CEL files to list"), wxITEM_NORMAL);
    fileMenu->Append(ID_FileExitMenu, wxT("Exit"), wxT("Exit Program"), wxITEM_NORMAL);
    m_menuBar->Append(fileMenu, wxT("File"));
    wxMenu* editMenu = new wxMenu();
    editMenu->Append(ID_EditPreferencesMenu, wxT("Preferences"), wxT(""), wxITEM_NORMAL);
    m_menuBar->Append(editMenu, wxT("Edit"));
    wxMenu* wxglade_tmp_menu_1 = new wxMenu();
    wxglade_tmp_menu_1->Append(ID_HelpAboutMenu, wxT("About"), wxT(""), wxITEM_NORMAL);
    wxglade_tmp_menu_1->Append(ID_HelpHelpMenu, wxT("Help"), wxT(""), wxITEM_NORMAL);
    m_menuBar->Append(wxglade_tmp_menu_1, wxT("Help"));
    m_statusBar = CreateStatusBar(1, 0);
    m_celFileSelectionPanel = new CELFileSelectionPanel(m_notebook, -1, wxDefaultPosition, wxDefaultSize, 0);
    m_rmaPanel = new RMAPanel(m_notebook, -1, wxDefaultPosition, wxDefaultSize, 0);
    m_masPanel = new MASPanel(m_notebook, -1, wxDefaultPosition);
    m_logWindow = new wxTextCtrl(panel_1, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY);

    set_properties();
    do_layout();
    // end wxGlade
    
  m_logger=new LogTextCtrl(m_logWindow);
  
  m_logOld = wxLog::SetActiveTarget(m_logger);
  wxLogMessage(_T("GENE initialized.\n"));
}


void MainFrame::set_properties()
{
    // begin wxGlade: MainFrame::set_properties
    SetTitle(wxT("GENE"));
    SetSize(wxSize(566, 687));
    int m_statusBar_widths[] = { -1 };
    m_statusBar->SetStatusWidths(1, m_statusBar_widths);
    const wxString m_statusBar_fields[] = {
        wxT("")
    };
    for(int i = 0; i < m_statusBar->GetFieldsCount(); ++i) {
        m_statusBar->SetStatusText(m_statusBar_fields[i], i);
    }
    m_logWindow->SetMinSize(wxSize(543, 73));
    // end wxGlade
}




void MainFrame::do_layout()
{
    // begin wxGlade: MainFrame::do_layout
    wxFlexGridSizer* m_frameSizer = new wxFlexGridSizer(2, 1, 0, 0);
    wxStaticBoxSizer* sizer_3 = new wxStaticBoxSizer(sizer_3_staticbox, wxHORIZONTAL);
    m_notebook->AddPage(m_celFileSelectionPanel, wxT("CEL Files"));
    m_notebook->AddPage(m_rmaPanel, wxT("RMA"));
    m_notebook->AddPage(m_masPanel, wxT("MAS 5.0"));
    m_frameSizer->Add(m_notebook, 1, wxEXPAND, 0);
    sizer_3->Add(m_logWindow, 1, wxEXPAND, 0);
    panel_1->SetAutoLayout(true);
    panel_1->SetSizer(sizer_3);
    sizer_3->Fit(panel_1);
    sizer_3->SetSizeHints(panel_1);
    m_frameSizer->Add(panel_1, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(m_frameSizer);
    m_frameSizer->AddGrowableRow(0);
    m_frameSizer->AddGrowableCol(0);
    Layout();
    // end wxGlade
}



void MainFrame::OnFileAddCELFiles(wxCommandEvent& event)
{
	m_notebook->SetSelection(0);
	m_celFileSelectionPanel->AddFiles(event);
	
}

void MainFrame::OnExit(wxCommandEvent& WXUNUSED(event))
{
	m_helpController->Quit();
	delete m_helpController;
  this->Destroy();
}


void MainFrame::ExecuteMAS(wxCommandEvent& WXUNUSED(event))
{
  int i;
  char **celfiles;
  wxArrayString files;
  int num_files;
  
  files=m_celFileSelectionPanel->GetCELFileList();
  num_files=files.GetCount();
  if ( num_files == 0 ) {
    wxMessageBox("No files selected","Warning",wxOK|wxICON_EXCLAMATION,this);
    return;
  }
  
  celfiles=(char **)calloc((num_files+1),sizeof(char *));
  for (i=0; i < num_files; i++) {
    celfiles[i]=strdup((char *)files[i].c_str());
  }
  
  
  // Then set all options through appropriate beans
  mi_setBackground(m_masPanel->GetBackground());
  mi_setMeanNormalization(m_masPanel->GetMeanNormalization());
  mi_setMeanNormalizationValue(m_masPanel->GetMeanNormalizationValue());
  mi_setScaleProbesets(m_masPanel->GetScaleProbesets());
  mi_setScaleProbesetsValue(m_masPanel->GetScaleProbesetsValue());
  
  mi_setOutputFile(m_masPanel->GetOutputFile().c_str());
  // CDF file can either be the file (explicitly) or
  // the directory (if other is empty).
  const char *cdf=m_celFileSelectionPanel->GetCDFFile().c_str();
  if ( strlen(cdf ) != 0 ) {
    mi_setCDFDirectory(cdf);
  } else {

    static wxConfigBase *cfg=wxConfigBase::Get();
    wxString defaultCDFDirectory;
    cfg->Read(DEFAULT_CDF_DIR_KEY,&defaultCDFDirectory, DEFAULT_CDF_DIR_VALUE);
    if (! defaultCDFDirectory.IsEmpty() ) {
      mi_setCDFDirectory(defaultCDFDirectory);
    }
  }

  // Disable timestamps during processing (cleaner)
  wxLogMessage("Starting MAS5.0\n");
  const wxChar *timestamp=m_logger->GetTimestamp();
  m_logger->SetTimestamp(NULL);
  // Call the MAS routine
  mi_callMAS(celfiles);
  // Restore the timestamp
  m_logger->SetTimestamp(timestamp);
  wxLogMessage("MAS5.0 Finished\n");
}

void MainFrame::ExecuteRMA(wxCommandEvent& WXUNUSED(event))
{
  int i;
  char **celfiles;
  wxArrayString files;
  int num_files;
  
  files=m_celFileSelectionPanel->GetCELFileList();
  num_files=files.GetCount();
  if ( num_files == 0 ) {
    wxMessageBox("No files selected","Warning",wxOK|wxICON_EXCLAMATION,this);
    return;
  }
  
  celfiles=(char **)calloc((num_files+1),sizeof(char *));
  for (i=0; i < num_files; i++) {
    celfiles[i]=strdup((char *)files[i].c_str());
  }
  
  
  // Then set all options through appropriate beans
  ri_setBackground(m_rmaPanel->GetBackground());
  ri_setNormalization(m_rmaPanel->GetNormalization().c_str());
  ri_setOutputFile(m_rmaPanel->GetOutputFile().c_str());
  
  // CDF file can either be the file (explicitly) or
  // the directory (if other is empty).
  const char *cdf=m_celFileSelectionPanel->GetCDFFile().c_str();
  if ( strlen(cdf ) != 0 ) {
    ri_setCDFDirectory(cdf);
  } else {
    static wxConfigBase *cfg=wxConfigBase::Get();
    wxString defaultCDFDirectory;
    cfg->Read(DEFAULT_CDF_DIR_KEY,&defaultCDFDirectory, DEFAULT_CDF_DIR_VALUE);
    if (! defaultCDFDirectory.IsEmpty() ) {
      ri_setCDFDirectory(defaultCDFDirectory);
    }
  }
  
  // Disable timestamps during processing (cleaner)
  wxLogMessage("Starting RMA\n");
  const wxChar *timestamp=m_logger->GetTimestamp();
  m_logger->SetTimestamp(NULL);
  // Call the process
  ri_callRMA(celfiles);	
  // Restore timestamps
  m_logger->SetTimestamp(timestamp);
  wxLogMessage("RMA Finished\n");

}

// Have a load deafults and set defaults metohd
//bool Read(const wxString& key, wxString* str, const wxString& defaultVal) const
void MainFrame::OnEditPreferences(wxCommandEvent& event)
{
  if ( m_preferencesDialog==NULL) {
    m_preferencesDialog=new PreferencesDialog(this,-1,wxT("Preferences"));
  }
  int result=m_preferencesDialog->ShowModal();

  
}

void MainFrame::OnAbout(wxCommandEvent &event)
{
	wxMessageBox("GENE: A Gene Expression and Normalization Engine\nSteven Eschrich and Andrew Hoerter\nv1.1, 2005","About GENE",wxOK|wxICON_INFORMATION);
}

void MainFrame::OnHelp(wxCommandEvent &event)
{
/*
        wxRegKey *pRegKey=new wxRegKey("HKEY_CURRENT_USER\\Software\\GENE");
        wxString path;

        if ( pRegKey->Exists() )
           pRegKey->QueryValue("InstallPath",path);
        else
           path=wxPathOnly(wxapp->argv[0]);
        path+="/doc/usermanual.zip";
	if ( m_helpController == NULL ) {
		m_helpController=new wxHtmlHelpController();
		wxFileSystem::AddHandler(new wxZipFSHandler);
		m_helpController->AddBook(wxFileName(path),true);
	}
	m_helpController->Display("index.html");
*/

}
